' module: similar words
declare sub similar(exercise as TExercise)
scope
  dim as TList pairsList
  with pairsList
    .listName = "multiple"
    .list.addAll(fullList.list)
    .load
    .sort
    .mix
    .save
    .list.clear
  end with
end scope
' TEMPORARY DEACTIVATED
'globalExercises.add(TExercise("Multiple Choice", "multiple", 0, @similar, @infoEmpty, @chooseWords))

sub similar(exercise as TExercise)
  dim as integer bx = 50, by = 100, bw = 150, bh = 40, bxp = 30, byp = 20, perLine = 4, maxLines = 3
  dim as integer maxEntries = perLine*maxLines
  dim as integer count, randNo, mx, my, mb
  dim as boolean solved

  ' prepare GUI
  enum
    posNone = 0, posLevels
    posRepeat = 10, posShow, posSpeak, posHelp
  end enum
  dim multGui as TGui, tempButton as TGuiButton
  dim as TGuiEvent event, eventNew
  ' special keys and levels of difficulty
  guiAddLevs multGui, posLevels, 40, 450, 100, 40, 20
  ' button: repeat question
  tempButton = TGuiButton(posRepeat, 60, 530, 120, 50, "Wiederholen", chr(9),, "Tab")
  tempButton.fontsize = 16
  multGui.buttons.add tempButton
  ' button: show correct answer
  tempButton = TGuiButton(posShow, 330, 530, 120, 50, "ANZEIGEN", chr(13),, "Enter")
  tempButton.fontsize = 16
  multGui.buttons.add tempButton
  ' button: speak word
  multGui.buttons.add _
      TGuiButton(posSpeak, exepath & "/img/speaker.bmp", 620, 530, 40, 40, chr(255, 60),, "F2", GuiState.noBorder)
  ' button: show program help
  multGui.buttons.add _
      TGuiButton(posHelp, exepath & "/img/help.bmp", 690, 530, 40, 40, chr(255, 59),, "F1", GuiState.noBorder)

  do
    dim as string t, answer(maxEntries), key
    dim as mdList(string) translations
    dim as TListPoint listPoint = exercise.currentList.list.get(0)
    dim as TWord w = globallist.get(listPoint.id)
    dim as TList l = levenshtein(w, exercise.fullList)
    count = 0
    solved = false
    for i as integer = maxEntries to 0 step -1
      w = globallist.get(l.list.get(i).id)
      foreach(string, t, w.translate)
        if not translations.contains(t) then
          count += 1
          randNo = int(rnd*iif(count>maxEntries, maxEntries, count))
          if randNo = count-1 then translations.add(t) else translations.add(randNo, t)
        end if
      nexteach
    next
    count = translations.size
    dim as boolean correct(count), marked(count)
    if count > maxEntries then count = maxEntries
    for i as integer = 0 to count-1
      answer(i) = translations.get(i)
      foreach(string, t, w.translate)
        if answer(i) = t then correct(i) = true
      nexteach
    next
    foreach(string, t, w.translate)
      for i as integer = 0 to count-1
        if answer(i) = t then correct(i) = true
      next
    nexteach
    screenlock
    cls
    printFT 50, 50, "Markieren Sie alle Übersetzungen von: " & w.word, font
    multGui.show
    screenunlock

    do
      getmouse mx, my,, mb
      sleep 1
    loop until mb = 0
    do
      key = inkey
      if key = chr(27) or key = chr(255, 107) then exit sub
      if not solved then
        'mb = checkButtons(bx, by, bw, bh, bxp, byp, perLine, count, 1)
        'if mb >= 0 then
        '  markButton bx, by, bw, bh, bxp, byp, perLine, mb
        '  marked(mb) = not marked(mb)
        '  do
        '    getmouse mx, my,, mb
        '    sleep 1
        '  loop until mb = 0
        'end if
      end if
      dim as integer cb '= checkExerciseButtons
      select case cb
        case GUI.enter
          if not solved then
            for i as integer = 0 to count
              if correct(i) then 
                'if marked(i) then
                '  markButton bx, by, bw, bh, bxp, byp, perLine, i, &hff00ff
                'else
                '  markButton bx, by, bw, bh, bxp, byp, perLine, i, &hffcccc
                'end if
              else
                'if marked(i) then markButton bx, by, bw, bh, bxp, byp, perLine, i, &h00ffff
              end if
            next
            solved = true
          end if
        case GUI.level to GUI.level+B_COUNT-1
          dim l as TListPoint, i as integer
          if cb >= GUI.level and cb <= GUI.level+B_COUNT-1 then
            listPoint.modify(cb-GUI.level)
          else
            listPoint.modify(key[1]-62)
          end if
          listPoint.position = now + listPoint.addition - rnd/10
          ' update position in exercise.fullList and exercise.currentList
          for lno as integer = 0 to 1
            dim as TList ptr listPtr = iif(lno=0, @exercise.fullList, @exercise.currentList)
            dim as integer index = iif(lno=0, listPtr->list.indexOf(listPoint), 0)
            for i = index+1 to listPtr->size - 1
              l = listPtr->list.get(i)
              if l.position > listPoint.position then exit for
            next
            if i = listPtr->size then
              listPtr->list.add(listPoint)
            else
              listPtr->list.add(i, listPoint)
            end if
            listPtr->list.remove(index)
            listPtr->update
          next
          exit do
        case GUI.speech
          speak w.word
      end select
      sleep 1
    loop
  loop
end sub
