#include once "xmlparse.bi"
#include once "TTextBlock.bi"

declare function help(as string, as string, as integer = 24, as integer = 24, as integer = 752, as integer = 552) as integer
declare sub helpAddHeadLevel(arr(any) as integer, as integer)
declare function helpWriteHeadLevel(arr(any) as integer) as string

function help(helpfile as string, id as string, _
         x as integer = 24, y as integer = 24, _
         w as integer = 752, h as integer = 552) as integer
  dim as TTextBlock textBlock
  dim as integer curHead, countHead(1 to 6), countLines = 0, posY = 0, mx, my, mw, mw2, mb, filenumber = freefile
  dim as string key
  open helpfile for input as filenumber
  dim as TypXML xml = xmlParse(xmlParse(, filenumber).inhalt)
  close filenumber
  do while xml.tag <> "body" andalso len(xml.rest)
    xml = xmlParse(xml.rest)
  loop
  if xml.tag <> "body" then return RETVAR.generalError
  xml = xmlParse(xml.inhalt)
  do
    sleep 1
  loop while getmouse(mx, my, mw)
  do
    if len(xml.tag) = 2 andalso xml.tag[0] = 104 and xml.tag[1] > 48 and xml.tag[1] < 55 then
      curHead = xml.tag[1]-48
      helpAddHeadLevel countHead(), curHead
      if xml.getAttr("id") = id then
        ' found start - looking for the end
        textBlock.add 700, helpWriteHeadLevel(countHead()) & " " & xml.inhalt, font, 15
        xml = xmlParse(xml.rest)
        do while len(xml.tag)
          if len(xml.tag) = 2 andalso xml.tag[0] = 104 and xml.tag[1] > 48 then
            if xml.tag[1] < curHead+49 then exit do
            helpAddHeadLevel countHead(), xml.tag[1]-48
            textBlock.add 700, "", font, 10
            textBlock.add 700, helpWriteHeadLevel(countHead()) & " " & xml.inhalt, font, 15
          elseif xml.tag = "p" then
            textBlock.add 700, "", font, 5
            textBlock.add 700, xml.inhalt, font, 13
          end if
          xml = xmlParse(xml.rest)
        loop
      end if
    end if
    xml = xmlParse(xml.rest)
  loop while len(xml.rest)

  dim as integer search, xPos = 0, yPos = 0, count = 0
  cls
  dim as FB.Image ptr textImg = textBlock.show
  if textImg = 0 then return RETVAR.generalError

  put (50, 50), textImg, (0, posY)-step(750, 500), pset

  dim helpGui as TGui, event as TGuiEvent
  dim as TGuiElement backButton, upButton, downButton
  backButton = TGuiElement(GuiElementType.button, 1, 650, 600, 120, 25, "zurück", chr(13))
  helpGui.addElement backButton
  if textImg->height > 500 then
    downButton = TGuiElement(GuiElementType.button, 2, exepath & "/img/down.bmp", 600, 600, 31, 30)
    upButton   = TGuiElement(GuiElementType.button, 3, exepath & "/img/up.bmp", 560, 600, 31, 30)
    upButton.state = GuiState.deactivated
    helpGui.addElement downButton
    helpGui.addElement upButton
  end if
  helpGui.show
  do
    getmouse(mx, my,, mb)
    sleep 1
  loop until mb < 1 
  do
    key = inkey
    event = helpGui.getEvent(key)
    if getmouse(mx, my, mw2)= 0 then
      if mw2 > mw then
        if upButton.state = GuiState.active then event.id = 5
      elseif mw2 < mw then
        if downButton.state = GuiState.active then event.id = 4
      end if
      mw = mw2
    end if
    if key = chr(255, 72) or key = chr(255, 73) then
      if upButton.state = GuiState.active then event.id = 5
    elseif key = chr(255, 80) or key = chr(255, 81) then
      if downButton.state = GuiState.active then event.id = 4
    end if
    select case event.id
      case 2, 4
        if posY = 0 then
          upButton.state = GuiState.active
          helpGui.setElement upButton
          upButton.show
        end if
        posY += 20
        if posY+500 > textImg->height then posY = textImg->height-500
        if posY+500 = textImg->height then
          downButton.state = GuiState.deactivated
          helpGui.setElement downButton
          downButton.show
        end if
        put (50, 50), textImg, (0, posY)-step(750, 499), pset
        if event.id = 2 then sleep 100
      case 3, 5
        if posY+500 >= textImg->height then
          downButton.state = GuiState.active
          helpGui.setElement downButton
          downButton.show
        end if
        posY -= 20
        if posY < 0 then posY = 0
        if posY = 0 then
          upButton.state = GuiState.deactivated
          helpGui.setElement upButton
          upButton.show
        end if
        put (50, 50), textImg, (0, posY)-step(750, 499), pset
        if event.id = 3 then sleep 100
    end select
  loop until event.id = 1 or key = chr(255, 107)
  imagedestroy textImg
  if key = chr(255, 107) then return RETVAR.windowClosed
  return RETVAR.ok
end function

sub helpAddHeadLevel(countHead(any) as integer, level as integer)
  countHead(level) += 1
  for i as integer = level+1 to 6
    countHead(i) = 0
  next
end sub

function helpWriteHeadLevel(countHead(any) as integer) as string
  dim as string ret = str(countHead(1))
  for i as integer = 2 to 6
    if countHead(i) = 0 then exit for
    ret &= "." & countHead(i)
  next
  return ret
end function
